/***************************************************************************
 *   Copyright (C) 2006 by Sergey Melderis   *
 *   sergey.melderis@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FILESPREFS_H
#define FILESPREFS_H

#include <kconfig.h>
#include <qmap.h>
                

/**
	@author Sergey Melderis <sergey.melderis@gmail.com>
*/
class FilesPrefs 
{
public:
    

    static FilesPrefs& self();

    void setConfig(KConfig *config);

    void setKeyUrlItem(const QString &key, const QString &url);

    void removeKey(const QString &key);

    void writeConfig();

    bool hasKey(QString &key);

    bool hasKeyAndUrl(QString &key, QString &url);

    QMap<QString, QString> keyUrlItems();
    
    ~FilesPrefs();
private:
    FilesPrefs();

    static FilesPrefs *m_self;
    QMap<QString, QString> m_map;

    KConfig *m_config;
    void readConfig();

};

#endif
